from lib.obter_configuracoes import obter_configuracoes
import sys
from lib.echo import echo
from lib.executar_validacoes_servidor_linux import executar_validacoes_servidor_linux
from lib.ClienteLinux import obter_cliente_linux
from lib.backup_volume import fazer_backup_volume_docker, restaurar_backup_volume_docker

arquivo_configuracao = None if len(sys.argv) < 2 else sys.argv[1]
diretorio_scripts_implantacao = r'c:\microuniversoWeb\scriptsImplantacao' if len(sys.argv) < 3 else sys.argv[2]

configuracoes = obter_configuracoes(arquivo_configuracao)

if not configuracoes["acessos"]["servidorLinux"]["configurar"]:
    echo("Dados do servidor linux nao informados. Api MuWhatsapp nao sera configurada")
    exit(0)

if not configuracoes["muWhatsapp"]["configurarApi"]:
    echo("Configuracao da api MuWhatsapp desativada via configuracao")
    exit(0)

mensagem_erro = executar_validacoes_servidor_linux(arquivo_configuracao, diretorio_scripts_implantacao)    

if mensagem_erro:
    echo(mensagem_erro, "error")
    exit(1)

cliente_linux = obter_cliente_linux(arquivo_configuracao)

usuario = configuracoes['acessos']['servidorLinux']['usuario']

if cliente_linux.executar_comando(f"test ! -d /home/{usuario}/muWhatsapp", disparar_excecao_se_retorno_nao_zero=False).codigo_retorno == 0:
    cliente_linux.executar_comando(f'mkdir /home/{usuario}/muWhatsapp')

cliente_linux.copiar_arquivo(fr'{diretorio_scripts_implantacao}\muWhatsapp\docker-compose-mu-whatsapp.yml' , f'/home/{usuario}/muWhatsapp/docker-compose.yml')


versao = configuracoes["muWhatsapp"]["versao"]
porta = configuracoes["muWhatsapp"]["porta"]

usuario_registro_docker = configuracoes["acessos"]["registroDocker"]["usuario"]
senha_registro_docker = configuracoes["acessos"]["registroDocker"]["senha"]

cliente_linux.executar_comando(fr'docker login gitlab.microuniverso.com.br:5050 -u {usuario_registro_docker} -p {senha_registro_docker}', disparar_excecao_se_retorno_nao_zero=False)


cliente_linux.executar_comando(fr"sed -i 's,\$VERSAO_MU_WHATSAPP,{versao},g' /home/{usuario}/muWhatsapp/docker-compose.yml")
cliente_linux.executar_comando(f"sed -i 's,\$PORTA,{porta},g' /home/{usuario}/muWhatsapp/docker-compose.yml")

try:
    fazer_backup_volume_docker("muwhatsapp_tokens", arquivo_configuracao)
    fazer_backup_volume_docker("muwhatsapp_user_data", arquivo_configuracao)
except:
    echo("Não foi possível Fazer Backup dos dados do MuWhatsapp Api")

cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/muWhatsapp/docker-compose.yml down')    
cliente_linux.executar_comando(f'docker compose -f /home/{usuario}/muWhatsapp/docker-compose.yml up -d') 

try:
    restaurar_backup_volume_docker("muwhatsapp_tokens", arquivo_configuracao)
    restaurar_backup_volume_docker("muwhatsapp_user_data", arquivo_configuracao)
except:
    echo("Não foi possível Restaurar os dados do MuWhatsapp Api")

   

exit(0)
